#pragma strict

var seconds: float = 60.0;
// Creates a 1 sec long audioclip, with a 440hz sinoid
var position: int = 0;
var sampleRate : int = 0;
var freqMin : float = 1000;
var freqMax : float = 1440;
var pitchMin : float = 0.2;
var pitchMax : float = 2.0;

private var topVolume	: float = 1.0;
private var debugVolume	: float = 0.5;

// Scripts
@System.NonSerialized var GAME 		: scr_GAME;
@System.NonSerialized var CHORUS 	: AudioChorusFilter;

function Start () {
	GAME = GameObject.Find("GAME").GetComponent(scr_GAME);
	CHORUS = gameObject.GetComponent(AudioChorusFilter);

	sampleRate = AudioSettings.outputSampleRate;
	var myClip = AudioClip.Create("TheAudio", sampleRate, 1, sampleRate, false, true, OnAudioRead, OnAudioSetPosition);
	audio.clip = myClip;
	audio.loop = true;
	audio.Play();
	
	topVolume = ( Debug.isDebugBuild ? debugVolume : 1.0 );
}
function OnAudioRead(data:float[])
{
	//var p : float = ( Input.mousePosition.y / parseFloat(Screen.height) );
	//frequency = LIB.LMapClamp( p, 0.0, 1.0, freqMin, freqMax );
	var f : float = freqMin;
	//Debug.Log("pos "+position+" / y "+Input.mousePosition.y+" / p "+p+" / f "+frequency);
	
	for (var count = 0; count < data.Length; count++)
	{
		data[count] = Mathf.Sign(Mathf.Sin(2 * Mathf.PI * f * position / sampleRate));
		position++;
	}
}
function OnAudioSetPosition(newPosition:int)
{
	position = newPosition;
}


function Update()
{
	//var p : float = ( Input.mousePosition.y / parseFloat(Screen.height) );
	var p : float = GAME.PROG;
	// playing
	if ( GAME.state <= GameState.Ready )
	{
		audio.volume = 0.0;
	}
	else if ( GAME.state <= GameState.Playing )
	{
		audio.volume = topVolume;
		audio.pitch = LIB.LMapClamp( p, 0.0, 1.0, pitchMin, pitchMax );
		CHORUS.enabled = ! GAME.HITTING;
	}
	// game over
	else
	{
		audio.volume = LIB.LMapClamp( p, 1.0, 1.2, topVolume, 0.0 );
		audio.pitch = LIB.LMapClamp( p, 1.0, 1.25, pitchMax, pitchMin );
		CHORUS.enabled = false;
	}
}    
